
%define with_ruby 0

%define perl_vendorarch %(eval "`%{_bindir}/perl -V:installvendorarch`"; echo $installvendorarch)

%define ruby_sitearch %(ruby -rrbconfig -e 'puts Config::CONFIG["sitearchdir"]')

%define python_sitearch %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")

# put Python bindings in site-packages
%define swigdirs swig_pydir=%{python_sitearch}/libsvn swig_pydir_extra=%{python_sitearch}/svn

Summary: Modern Version Control System designed to replace CVS
Name: subversion
Version: 1.7.4
Release: 2
License: ASL 1.1
Group: Development/Tools
URL: http://subversion.apache.org/
Source0: http://subversion.tigris.org/tarballs/%{name}-%{version}.tar.bz2
Source1: http://subversion.tigris.org/tarballs/%{name}-%{version}.tar.bz2.asc
Source2: http://subversion.tigris.org/tarballs/%{name}-%{version}.tar.bz2.sha1
Source3: httpd-subversion.conf
Patch0: %{name}-%{version}-aix.patch
BuildRequires: apr-devel >= 1.3.12, apr-util-devel >= 1.3.9
BuildRequires: expat-devel >= 2.0.0
BuildRequires: file-devel >= 5.05-1
BuildRequires: gettext
BuildRequires: neon-devel >= 0.29.3
BuildRequires: openssl-devel >= 0.9.8
BuildRequires: sqlite-devel >= 3.6.23.1
BuildRequires: swig >= 1.3.40
Requires: apr >= 1.3.12, apr-util >= 1.3.9, gettext
Requires: expat >= 2.0.0
Requires: file-libs >= 5.05-1
Requires: openssl >= 0.9.8
Requires: neon >= 0.29.3-2, sqlite >= 3.6.23.1, zlib
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Provides: svn = %{version}-%{release}

%description
Subversion is a concurrent version control system which enables one
or more users to collaborate in developing and maintaining a
hierarchy of files and directories while keeping a history of all
changes.  Subversion only stores the differences between versions,
instead of every complete file.  Subversion is intended to be a
compelling replacement for CVS.


%package devel
Group: Development/Tools
Summary: Development package for the Subversion libraries
Requires: %{name} = %{version}-%{release}
Requires: apr-devel >= 1.3.12, apr-util-devel >= 1.3.9
Requires: openssl-devel >= 0.9.8
Requires: neon-devel >= 0.29.3-2, sqlite-devel >= 3.6.23.1, zlib-devel

%description devel
The subversion-devel package includes the static libraries and
include files for developers interacting with the subversion
package.


%package -n mod_dav_svn
Group: System Environment/Daemons
Summary: Apache server module for Subversion server
Requires: httpd >= 2.2.15
Requires: %{name} = %{version}-%{release}
BuildRequires: httpd-devel >= 2.2.15

%description -n mod_dav_svn
The mod_dav_svn package allows access to a Subversion repository
using HTTP, via the Apache httpd server.


%package perl
Group: Development/Libraries
Summary: Perl bindings to the Subversion libraries
BuildRequires: perl >= 5.8.8
Requires: perl >= 5.8.8
Requires: %(eval `%{_bindir}/perl -V:version`; echo "perl(:MODULE_COMPAT_$version)")
Requires: %{name} = %{version}-%{release}

%description perl
This package includes the Perl bindings to the Subversion libraries.


%package python
Group: Development/Libraries
Summary: Python bindings for Subversion Version Control system
BuildRequires: python-devel >= 2.6.2
Requires: python >= 2.6.2

%description python
The subversion-python package includes the Python bindings to the
Subversion libraries.


%if %{with_ruby}
%package ruby
Group: Development/Libraries
Summary: Ruby bindings to the Subversion libraries
BuildRequires: ruby-devel >= 1.9.1, ruby >= 1.9.1
Requires: %{name} = %{version}-%{release}
Conflicts: ruby-libs < 1.8.2
### this should not be hard-coded!
Requires: ruby(abi) = 1.9.1

%description ruby
This package includes the Ruby bindings to the Subversion libraries.
%endif


%prep
%setup -q
%patch0


%build
export CONFIG_SHELL=/usr/bin/ksh
export CONFIG_ENV_ARGS=/usr/bin/ksh

export CC=xlc_r
export CPPFLAGS="-DSVN_NEON_0_26 -DSVN_NEON_0_25"
# need to use run-time-linking since version 1.7.0
export LDFLAGS="-L/opt/freeware/lib -Wl,-bmaxdata:0x80000000 -Wl,-brtl"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --disable-neon-version-check \
    --disable-mod-activation \
    --with-neon=%{_prefix} \
    --with-serf=%{_prefix} \
    --with-apxs=%{_sbindir}/apxs \
    --with-sqlite=%{_prefix} \
    --with-ssl \
    --with-openssl \
    --with-zlib=%{_prefix} \
    --with-swig=%{_prefix} \
%if %{with_ruby}
    --with-ruby-sitedir=%{ruby_sitearch}
%endif

make %{?_smp_mflags}
make swig-py swig-py-lib %{swigdirs}
make CC="gcc" swig-pl swig-pl-lib
%if %{with_ruby}
make swig-rb swig-rb-lib
%endif


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
export PATH=/opt/freeware/bin:$PATH

make DESTDIR=${RPM_BUILD_ROOT} install
make DESTDIR=${RPM_BUILD_ROOT} install-swig-pl-lib %{swigdirs}
make DESTDIR=${RPM_BUILD_ROOT} install-swig-py %{swigdirs}
%if %{with_ruby}
make DESTDIR=${RPM_BUILD_ROOT} install-swig-rb %{swigdirs}
%endif

make pure_vendor_install -C subversion/bindings/swig/perl/native \
        PERL_INSTALL_ROOT=${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/subversion
chmod 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/subversion

/usr/bin/strip ${RPM_BUILD_ROOT}%{_bindir}/* || :

# add subversion.conf configuration file into httpd/conf/extra directory.
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra
chmod 755 ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra
cp %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra
chmod 644 ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra/*

# Rename authz_svn INSTALL doc for docdir
ln -f subversion/mod_authz_svn/INSTALL mod_authz_svn-INSTALL

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%post -n mod_dav_svn
cat %{_sysconfdir}/httpd/conf/httpd.conf | \
  grep -v "# Subversion settings" | \
  grep -v "Include conf/extra/httpd-subversion.conf" \
  > %{_sysconfdir}/httpd/conf/tmp_httpd.conf
mv -f %{_sysconfdir}/httpd/conf/tmp_httpd.conf %{_sysconfdir}/httpd/conf/httpd.conf
echo "# Subversion settings" >> %{_sysconfdir}/httpd/conf/httpd.conf
echo "Include conf/extra/httpd-subversion.conf" >> %{_sysconfdir}/httpd/conf/httpd.conf
echo "Please restart your web server using: '/opt/freeware/sbin/apachectl restart'"


%preun -n mod_dav_svn
if [ "$1" = 0 ]; then
    cat %{_sysconfdir}/httpd/conf/httpd.conf | \
      grep -v "# Subversion settings" | \
      grep -v "Include conf/extra/httpd-subversion.conf" \
      > %{_sysconfdir}/httpd/conf/tmp_httpd.conf
    mv -f %{_sysconfdir}/httpd/conf/tmp_httpd.conf %{_sysconfdir}/httpd/conf/httpd.conf
    echo "Please restart your web server using: '/opt/freeware/sbin/apachectl restart'"
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc BUGS CHANGES COMMITTERS INSTALL README
%doc tools subversion/LICENSE mod_authz_svn-INSTALL
%{_bindir}/*
%{_libdir}/libsvn_[c,d,f,r,w]*.so*
%{_libdir}/libsvn_su*.so*
%{_mandir}/man[1,5,8]/*
%{_datadir}/locale/*/*/*
/usr/bin/*
/usr/lib/libsvn_[c,d,f,r,w]*.so*
/usr/lib/libsvn_su*.so*


%files devel
%defattr(-,root,system)
%{_includedir}/*
%{_libdir}/libsvn_[c,d,f,r,w]*.*a
%{_libdir}/libsvn_su*.*a
/usr/include/*
/usr/lib/libsvn_[c,d,f,r,w]*.*a
/usr/lib/libsvn_su*.*a


%files -n mod_dav_svn
%defattr(-,root,system)
%config(noreplace) %{_sysconfdir}/httpd/conf/extra/httpd-subversion.conf
%{_libdir}/httpd/modules/mod_*.so


%files perl
%defattr(-,root,system,-)
%{perl_vendorarch}/auto/SVN
%{perl_vendorarch}/SVN
%{_libdir}/libsvn_swig_perl*
/usr/lib/libsvn_swig_perl*
%{_mandir}/man3/*::*


%files python
%defattr(-,root,system)
%{python_sitearch}/libsvn
%{python_sitearch}/svn
%{_libdir}/libsvn_swig_py*
/usr/lib/libsvn_swig_py*


%if %{with_ruby}
%files ruby
%defattr(-,root,system,-)
%{ruby_sitearch}/svn
%{_libdir}/libsvn_swig_ruby*
/usr/lib/libsvn_swig_ruby*
%endif


%changelog
* Thu Apr 19 2012 Michael Perzl <michael@perzl.org> - 1.7.4-2
- fixed run-time-linking of sqlite3 against libsvn_subr*.so

* Thu Mar 15 2012 Michael Perzl <michael@perzl.org> - 1.7.4-1
- updated to version 1.7.4

* Wed Mar 14 2012 Michael Perzl <michael@perzl.org> - 1.7.3-2
- added Perl and Python bindings

* Tue Feb 14 2012 Michael Perzl <michael@perzl.org> - 1.7.3-1
- updated to version 1.7.3

* Sat Dec 10 2011 Michael Perzl <michael@perzl.org> - 1.7.2-1
- updated to version 1.7.2

* Sat Dec 10 2011 Michael Perzl <michael@perzl.org> - 1.7.1-3
- added missing dependency on openssl

* Tue Nov 22 2011 Michael Perzl <michael@perzl.org> - 1.7.1-2
- added missing dependency on file-libs

* Thu Nov 03 2011 Michael Perzl <michael@perzl.org> - 1.7.1-1
- updated to version 1.7.1

* Wed Oct 12 2011 Michael Perzl <michael@perzl.org> - 1.7.0-1
- updated to version 1.7.0

* Fri Jul 01 2011 Michael Perzl <michael@perzl.org> - 1.6.17-1
- updated to version 1.6.17

* Wed Mar 16 2011 Michael Perzl <michael@perzl.org> - 1.6.16-1
- updated to version 1.6.16

* Tue Dec 07 2010 Michael Perzl <michael@perzl.org> - 1.6.15-1
- updated to version 1.6.15

* Thu Oct 07 2010 Michael Perzl <michael@perzl.org> - 1.6.13-1
- updated to version 1.6.13

* Mon Jul 12 2010 Michael Perzl <michael@perzl.org> - 1.6.12-1
- updated to version 1.6.12

* Mon Jul 12 2010 Michael Perzl <michael@perzl.org> - 1.6.9-2
- removed dependency on gettext >= 0.17

* Thu Feb 11 2010 Michael Perzl <michael@perzl.org> - 1.6.9-1
- updated to version 1.6.9

* Thu Oct 22 2009 Michael Perzl <michael@perzl.org> - 1.6.6-1
- updated to version 1.6.6

* Tue Aug 25 2009 Michael Perzl <michael@perzl.org> - 1.6.5-1
- updated to version 1.6.5

* Mon Aug 10 2009 Michael Perzl <michael@perzl.org> - 1.6.4-1
- updated to version 1.6.4

* Wed Jun 24 2009 Michael Perzl <michael@perzl.org> - 1.6.3-1
- updated to version 1.6.3

* Wed Jun 24 2009 Michael Perzl <michael@perzl.org> - 1.6.2-1
- updated to version 1.6.2

* Wed Jun 24 2009 Michael Perzl <michael@perzl.org> - 1.6.1-1
- updated to version 1.6.1

* Wed Jun 24 2009 Michael Perzl <michael@perzl.org> - 1.6.0-1
- updated to version 1.6.0

* Wed Jun 24 2009 Michael Perzl <michael@perzl.org> - 1.5.6-1
- updated to version 1.5.6

* Tue Dec 23 2008 Michael Perzl <michael@perzl.org> - 1.5.5-1
- updated to version 1.5.5

* Thu Oct 23 2008 Michael Perzl <michael@perzl.org> - 1.5.4-1
- updated to version 1.5.4

* Mon Sep 01 2008 Michael Perzl <michael@perzl.org> - 1.5.2-1
- updated to version 1.5.2

* Wed Apr 23 2008 Michael Perzl <michael@perzl.org> - 1.4.6-2
- recompiled with newer version of expat and some spec file fixes

* Fri Dec 21 2007 Michael Perzl <michael@perzl.org> - 1.4.6-1
- updated to version 1.4.6

* Wed Dec 19 2007 Michael Perzl <michael@perzl.org> - 1.4.5-1
- first version for AIX V5.1 and higher
